/*---------------------------------------------------------------------------

															      Actor v1.0
  Eneko Bilbao 1999
---------------------------------------------------------------------------*/

/* 
    inherits from the Model class.
    implements mesh handling and 
    openGL interface.
*/

/* STATUS
    -   the display list are ok.
*/

/* TODO
    -		optimize the display list
    -		add support for texture coordinates.
    -		add a hierarchical system for multiple meshes.
    -   make better use of triangle strips
*/    

/* BUGS
    -		the objects are looking strange, problem with strips
*/


#ifndef _ACTOR_H_
#define _ACTOR_H_


#include <GL/gl.h>

#include "model.h"
#include "mesh.h"


class Actor:public Model
{
    private:
		    Mesh aspect;
		    GLuint list_id;
		    
    public:
		Actor():Model()
		{
		    list_id = 0;
		}
	    
	    ~Actor()
		{
		}
		
		void		Render(void);
		void		makeList(void);
		
		void		loadFromFile(char *);
		void		scaleMesh(float);
		void		Translate(float, float, float);
		
		void		makeCube(void);
		void 		makeSphere(void);
		void 		makeTorus(void);
	    void 			makeCylinder(void);	
	    
	    inline  GLuint		getListId(void)
		{ return(list_id); }
};

#endif	/*------------end-of-class-definition-------------*/
