/*---------------------------------------------------------------------------

															      Camera v1.0
  Eneko Bilbao 1999
---------------------------------------------------------------------------*/

/* 
 Derives from Model
 implements basic camera functions
*/

/* STATUS
    -   quake walk works.
    -		uses realtime cos and sin. (bad)
    -   Lens not used
*/

/* TODO
    -		uses the Lens
    -		use  lookup table for cos and sin
    -		make a link with a viewport class
*/    

/* BUGS
    -		round off problem with small walues
    -		the lookup table does not work.
*/

#ifndef _CAMERA_H_
#define _CAMERA_H_

#include "model.h"
#include <math.h>
#define PI_2 6.283185307179586232

class Camera:public Model
{
    private:
            float   lens;           // fov
            int     width, height;  // size of the viewport
			
    public:
            Camera():Model()
            {
              setFriction(0.05);
            }
            
            Camera(float a, float b, float c):Model()
            {
              lens = 0 ; width = 0 ; height = 0 ;
            }
            
            Camera(float l):Model()
            {
                lens = l;
            }
            
            Camera(int w, int h, float l):Model()
            {
                width = w ; height = h;
                lens = l ;
            }
            
            ~Camera(void)
            {
            }
            
            inline void    setLens(float l)
            {   lens = l ;}
            
            inline float   getLens(void)
            {   return(lens); }
                
            void Travel(float a, float b, float c);

};

#endif /*-----------_CAMERA_H_---------*/

