/*---------------------------------------------
				Tool Class 
 ----------------------------------------------
 
 Contains a trigonometric lookup table to avoid
 all theses sin & cos.
 ----------------------------------------------*/


#ifndef _UTILITY_
#define _UTILITY_

#include <math.h>

class utility
{
	private:
		float *tcos;
	    
	public:
			utility( void )
			{
				tcos = new float[360];
				BuildTrigo();
			}	

			~utility( void )
			{ 
				delete[] tcos ;
			}
			
			inline float COS( int d )
			{ 	
				if ( d > 0 )
					return(tcos[d]);
			    else
					return(tcos[(360+d +180)%360]);
			}	
				

			inline float SIN( int d )
			{ 				
				if ( d > 0 )
					return( tcos[d+180]);
			    else
					return(tcos[180+d]);
			}
			
			void BuildTrigo(void);
};
#endif /*-----------------------------------------*/
